/////////////////////////////////////////////////////////////////////
// inputs pins port B 4-7 = buttons 1-4 toggle output portB pin 0..3
// a runtime high on pin A1 reset = reset the device except eeprom
// a runtime high at of the A3 load pin will load the eeprom value provided there is no input at port B4..7 
// if there is a pin active this will load instead and following transistions made
// a runtime high at pin A3 load pin will load the saved eeprom value to current
// a runtime high of pin A2 will save the bus state {invert isnt specific here... }setting to eeprom
// a saved nibble value will be reloaded upon reboot as long as there is no low/high activity on B4-B7 pins
// you can toggle the mclr pin to reset any pic i added this detail to the schematic also
/////////////////////////////////
// build 3 30_11_2007  01:00 gmt
// fixed bug... inital pin setup wasnt toggled correctly when a pin was high on boot 
// and a toggle was made from high to low on a pin set high 
// at boot for the first few itterations failed to update the nibble correctly
// removed ...  white space from the sources and folded the functions to lines to tidy the code struct
/////////////////////////////////////////////////////////////////////////////////////////////// 
#include "buttonbinarator.h" // this is the header for the whole class
#include "4bit.c" // this is the 4bit nibble portb driver class
#define LOWTOHIGH TRUE // transitional difines
#define HIGHTOLOW FALSE
BIT dbutton[4];   //data from button interrupt cast this is class wide so goes here
// interrupt and detect any change on pins portB b4-b7
#int_rb
void detect_rb_change() {
   int current;
   static int last=0;
   set_tris_b(0xF0);
   current=input_b();
   #if LOWTOHIGH
   if ((!bit_test(last,4))&&(bit_test(current,4))) {dbutton[0]=1;}
   if ((!bit_test(last,5))&&(bit_test(current,5))) {dbutton[1]=1;}
   if ((!bit_test(last,6))&&(bit_test(current,6))) {dbutton[2]=1;}
   if ((!bit_test(last,7))&&(bit_test(current,7))) {dbutton[3]=1;}
   #elif HIGHTOLOW
   if ((!bit_test(current,4))&&(bit_test(last,4))) {dbutton[0]=1;}
   if ((!bit_test(current,5))&&(bit_test(last,5))) {dbutton[1]=1;}
   if ((!bit_test(current,6))&&(bit_test(last,6))) {dbutton[2]=1;}
   if ((!bit_test(current,7))&&(bit_test(last,7))) {dbutton[3]=1;}
   #endif
   last=current;
}
//////////////////////////
// main runtime routine //
//////////////////////////
void main() {
   ///////////////
   // VARIABLES //
   ////////////////////////////////////
   BIT BTN1,BTN2,BTN3,BTN4,newdata;  // this cast isnt class wide and is contained in main
   int button[4]; 
   int8 inreg,outreg,t;
   ///////////////////////// good practice to null the variables/flags
   BTN1=BTN2=BTN3=BTN3=FALSE;
   button[0]=button[1]=button[2]=button[3]=0;  
   inreg=outreg=t=0;  
   // the registers states can ONLY be read and written after the global interrupts are enabled
   enable_interrupts(GLOBAL);
   // this line takes the value of the bport and moves the position pointer right by 4 to get to the data we need in the byte
   inreg=(input_b()>>0x04);   
   // load eeprom value if no buttons preset on boot if there is then load there snap shot value
   if(inreg==0x00) { inreg=read_eeprom(0x00); } 
   // load the flip flops inital state from the inregister variable loaded above 
   for(t=0;t<=3;){ if(bit_test(inreg,t)) { bit_set(button[t],0);}else { bit_clear(button[t],0);} t++; }
   // enable port B pins 4-7 interrupt on activity //   
   enable_interrupts(INT_RB); 
   // main routine 
   do{ // do...while (1) is simply a never ending loop to escape we use a variable like do{ if (willescape)x=FALSE; } while(x);
      //reset pin detect 
      BTN1=input(PIN_A0);if(BTN1) { inreg=outreg=0x00;for(t=0;t<=3;){button[t]=0x00;t++;}} // null the variables and flipflops
      // save eeprom pin detect
      BTN3=input(PIN_A2);if(BTN3) { write_eeprom(0x00,inreg); } // save the data too the eeprom at address 0x00 {first byte of the eeprom}
      // load eeprom pin detect
      BTN4=input(PIN_A3);if(BTN4) { inreg=read_eeprom(0x00); // read address 0x00 in the eeprom and set in reg and flipflops to the read value
          for(t=0;t<=3;){ if(bit_test(inreg,t)) { bit_set(button[t],0);}else { bit_clear(button[t],0);} t++; }
          newdata=TRUE; // flag a new data event // needed to update the flipflops of the next buttons state will be wrong
      }
      ///////////////////////////////////////////////////////////////////////
      // GET INTERRUPT BUTTON ACTITIY AND FLIP FLOP ON HIGH LOW            //
      ///////////////////////////////////////////////////////////////////////
      if(dbutton[0]) { button[0]= !button[0]; dbutton[0]=FALSE;newdata=TRUE;} 
      if(dbutton[1]) { button[1]= !button[1]; dbutton[1]=FALSE;newdata=TRUE;}
      if(dbutton[2]) { button[2]= !button[2]; dbutton[2]=FALSE;newdata=TRUE;} 
      if(dbutton[3]) { button[3]= !button[3]; dbutton[3]=FALSE;newdata=TRUE;}
      ///////////////////////////////////////////////////////////////////////
      // scan flip flop buttons[x] and set the inregister to the same bit value
      //////////////////////////////////////////////////////////////////////////
      if(newdata){for(t=0;t<=3;){ if(bit_test(button[t],0)) { bit_set(inreg,t);}else { bit_clear(inreg,t);} t++; } newdata=FALSE; }
      // get invert output pin A1 state
      BTN2=input(PIN_A1);
      // deal with invert outputs sets the outregister to the inreg value or to the invert of the inreg value
      if(!BTN2) { outreg=inreg; } else if(BTN2){ outreg=~inreg; }
      PORT4BIT_WRITE(outreg); // send the outvalue nibble to the 4 bit port class 4bit.c attached 
   }while(TRUE); // do forever
}
////////////////
// THE END... /////////////////////////////////////////////
// THIS CODE WAS MADE BY SIMEON WEBBER M.C.A ~30_11_2007 //
//////////////////////////////////////////////////////////////////////////////////////////
// I USED CCS COMPILER FOR THE MAIN WORK AND QUICKBUILDER FOR THE 4 BITSET PORTB OUTPUT //
//////////////////////////////////////////////////////////////////////////////////////////
